########################################
#                                      #
# 版权所有 (c) 2008 杜俊(本科毕设作品) #
#                                      #
# 开发平台：Series 60 C++ SDKs         #
#           Python For S60 SDK         #
#                                      #
# 编辑软件：PythonWin  Notepad2        #
#                                      #
# 测试机型：诺基亚6670                 #
#                                      #
# 完成日期：2008年5月                  #
#                                      #
########################################

# -*- coding:utf-8 -*-

# 导入必要的模块 
import	os , e32          # 系统级服务
import	appuifw           # UI框架
import	inbox             # 短信子系统接口
import	e32dbm            # 数据库操作
import	time              # 时间处理
from	graphics import * # 图象操作

import miso
import thread
def lighton():  # 背景灯长亮
	while 1:
		miso.reset_inactivity_time()
		e32.ao_sleep(5)
thread.start_new_thread(lighton, ())

# 主界面
def background():
	appuifw.app.screen = 'full'
	appuifw.app.title = '裁决之刃'.decode("utf-8")
	appuifw.app.exit_key_handler = exit

	# 全局变量
	global running
	running = 0   # 程序运行状态(1＝运行中 0＝未运行)

	# 绘制主界面背景图
	filename = "e:\\system\\apps\\DJSMSJD\\PIC\\bg.jpg" # 背景图片文件
	bgpic = Image.open(filename)
	def drawbg(rect):
		canvas.blit(bgpic,(0,0,176,208))

	canvas = appuifw.Canvas(redraw_callback = drawbg)
	appuifw.app.body = canvas

	# 主界面菜单
	appuifw.app.menu = [
						('裁决'.decode("utf-8"),smsjd),
						('设置'.decode("utf-8"),setup),
						(('帮助'.decode("utf-8")),
							(('关于信息'.decode("utf-8"),about),
							('使用说明'.decode("utf-8"),help))),
						('退出'.decode("utf-8"),exit)
																	]

# 关于信息
def about():
	appuifw.app.screen = 'normal'
	appuifw.app.exit_key_handler = background
	appuifw.app.set_tabs([] , None)
	canvas = appuifw.Canvas()
	appuifw.app.body = canvas
	canvas.text((55,20),'杜俊作品'.decode("utf-8"),0xff0232,'title')
	canvas.text((10,40),'二〇〇八'.decode("utf-8"),0xab1f7e,'title')
	canvas.text((100,40),'本科毕设'.decode("utf-8"),0xab1f7e,'title')
	canvas.text((10,60),'宁波大学信息科学与工程学院'.decode("utf-8"),0xab1f7e,'dense')
	canvas.text((55,90),'|'.decode("utf-8"),0x000000,'dense')
	canvas.text((9,100),'V I S I T  |'.decode("utf-8"),0x000000,'dense')
	canvas.text((20,115),'shagon.51.com'.decode("utf-8"),0xff0232,'title')
	canvas.text((55,130),'| 4  MORE'.decode("utf-8"),0x000000,'dense')
	canvas.text((55,140),'|'.decode("utf-8"),0x000000,'dense') 

# 使用说明
def help():
	appuifw.app.screen = 'normal'
	appuifw.app.title = '正在读取……'.decode("utf-8")
	appuifw.app.body = appuifw.Text(u'')
	appuifw.app.set_tabs([] , None)
	appuifw.app.exit_key_handler = background

	helpfile = "e:\\system\\apps\\DJSMSJD\\DATA\\help.txt"  # 读取帮助文件
	file = open(helpfile, 'r')
	txt = file.read().decode("utf-8")
	file.close()

	def catalog():
		choices = ['1.概述'.decode("utf-8") , '2.版权声明'.decode("utf-8") , '3.使用协议'.decode("utf-8") , '4.主菜单'.decode("utf-8") , '5.主功能'.decode("utf-8") , '6.更新历史'.decode("utf-8") , '7.用户反馈'.decode("utf-8")]
		index = appuifw.popup_menu(choices, '目录'.decode("utf-8"))
		if		0 == index :
				appuifw.app.body.set(txt)
				appuifw.app.body.set_pos(0)
		elif	1 == index : 
				appuifw.app.body.set(txt)
				appuifw.app.body.set_pos(88)
		elif	2 == index : 
				appuifw.app.body.set(txt)
				appuifw.app.body.set_pos(201)
		elif	3 == index : 
				appuifw.app.body.set(txt)
				appuifw.app.body.set_pos(531)
		elif	4 == index : 
				appuifw.app.body.set(txt)
				appuifw.app.body.set_pos(681)
		elif	5 == index : 
				appuifw.app.body.set(txt)
				appuifw.app.body.set_pos(1180)
		elif	6 == index : 
				appuifw.app.body.set(txt)
				appuifw.app.body.set_pos(1346)
		else               :
				pass

	appuifw.app.title = '使用说明'.decode("utf-8")
	appuifw.app.body = appuifw.Text(txt)
	appuifw.app.body.set_pos(0)
	appuifw.app.menu = [('目录'.decode("utf-8") , catalog)]


# 用户设定
def setup():
	def setupconfig(setkey , setvalue):
		configure = "e:\\system\\apps\\DJSMSJD\\DATA\\config"  # 读取配置文件
		configfile = e32dbm.open(configure,'w')
		configfile[setkey] = setvalue
		configfile.close()
	global soundset , passwordset
	choices = []
	if	0 == soundset :
		choices.append('开启音效'.decode("utf-8"))
	else :
		choices.append('关闭音效'.decode("utf-8"))
	if	"0" == passwordset :
		choices.append('更改口令'.decode("utf-8"))
	else :
		choices.append('关闭口令'.decode("utf-8"))

	index = appuifw.popup_menu(choices, '用户设置'.decode("utf-8"))
	if		0 == index :  # 设置音效
			if	0 == soundset :
				soundset = 1
				setupconfig("sound" , "on")
				appuifw.note('已开启音效'.decode("utf-8"),'conf')
			else :
				soundset = 0
				setupconfig("sound" , "off")
				appuifw.note('已关闭音效'.decode("utf-8"),'conf')
	elif	1 == index :  # 设置口令
			if	"0" == passwordset :
				while 1 :
					while 1 :
						psw1 = appuifw.query('输入新口令'.decode("utf-8"),'code')
						if	2 > len(psw1) :
							appuifw.note('口令过短'.decode("utf-8"),'error')
						else :
							break
					while 1 :
						psw2 = appuifw.query('再次输入新口令'.decode("utf-8"),'code')
						if	2 > len(psw2) : 
							appuifw.note('口令过短'.decode("utf-8"),'error')
						else :
							break
					if	psw1 <> psw2 :
						appuifw.note('两次口令不一致'.decode("utf-8"),'error')
					else :
						passwordset = psw1
						setupconfig("password" , passwordset)
						break
				appuifw.note('已更改口令'.decode("utf-8"),'conf')
			else :
				passwordset = "0"
				setupconfig("password" , passwordset)
				appuifw.note('已关闭口令'.decode("utf-8"),'conf')
	else :
			pass

# 退出
def exit():
	global running
	if	0 == running :
		appuifw.app.set_exit()
	else:
		if	appuifw.query('程序正在运行\n是否强制退出'.decode("utf-8"),'query'):
			appuifw.app.set_exit()
		else:
			background()

# 裁决选项
def smsjd():
	appuifw.app.screen = 'normal'
	appuifw.app.title = '裁决之刃'.decode("utf-8")
	appuifw.app.exit_key_handler = background

	global op
	op = 31 # 如果用户默认为全部信箱，则op无法取值，所以必须设定初值

	def handler():
		index = appbody.current()

		global op
		if	31 == op : op = 0

		if		0 == index  : op_contact(op)
		elif	1 == index  : op_keyword_check(op)
		elif	2 == index  : op_time(op)
		elif	3 == index  : op_byte(op)
		else				: pass

	options = ['联系人索引'.decode("utf-8"),'关键字搜索'.decode("utf-8"),'时间段筛选'.decode("utf-8"),'字符数筛选'.decode("utf-8")]

	appbody = appuifw.Listbox(options, handler)

	def handle_tab(index):
		global op
		op = index
		appuifw.app.body = appbody

	appuifw.app.set_tabs(['全   部'.decode("utf-8"),'收件箱'.decode("utf-8"),'已发箱'.decode("utf-8"),'发件箱'.decode("utf-8"),'草稿箱'.decode("utf-8")],handle_tab)
	appuifw.app.body = appbody


# 联系人索引
def op_contact(box):
	global running
	running = 1   # 程序运行状态置为运行中，下同

	# 读联系人数据文件
	def readboxfile(boxname):
		root = "e:\\system\\apps\\DJSMSJD\\DATA\\"
		filename = root + boxname
		file = open(filename,'r')
		content = file.read()
		dic = eval(content)
		file.close()
		return dic

	# 写联系人数据文件
	def writeboxfile(boxname , dic):
		root = "e:\\system\\apps\\DJSMSJD\\DATA\\"
		filename = root + boxname
		file = open(filename,'w')
		file.write(repr(dic))
		file.close()

	# 处理指定信箱，列出所有联系人列表
	def searchbox(boxname):
		global smsbox
		m = smsbox.sms_messages()
		if	0 <> len(m) :  # 如果当前信箱为空则不进行后续处理
			invalid = 0 # 失效标志
			boxdic = readboxfile(boxname)

			# 检测当前信箱联系人数据中最后访问地址是否有效
			try:
				check = smsbox.address(boxdic.get(0))
			except:
				invalid = 1

			# 检测当前信箱联系人数据是否有效
			name = boxdic.keys()
			name.remove(0)  # 0键存储的值是最后访问地址，不包含在联系人数据中
			if	0 < len(name) : 
				for i in range(0 , len(name)): # 逐个检测联系人数据是否有效
					seq = boxdic.get(name[i])

					try:                                 # 联系人首地址
						check = smsbox.address(seq[0])
					except:
						seq[0] = 0

					try:                                 # 联系人尾地址
						check = smsbox.address(seq[1])
					except:
						seq[1] = 0

					if	0 == seq[0] or 0 == seq[1] :     # 如果有一处地址被破坏则进行处理
						boxdic[name[i]] = [seq[0],seq[1]]
						if	0 == seq[0] + seq[1] :
							invalid = 2
							break

			if		2 == invalid or 0 == len(name) : # 联系人数据被毁，无效
					boxdic.clear() # 清空无效数据
					boxdic[0] = 0
			elif	1 == invalid :                   # 首地址被毁，但联系人数据未毁，可恢复
					val = boxdic.values()
					val.remove(boxdic.get(0))
					val.sort()
					val.reverse()
					boxdic[0] = val[0][0]
			else:
					pass

			# 检查新增的短信联系人是否在数据库中，不存在则插入
			try:
				lastm = m.index(boxdic.get(0))
			except:
				lastm = len(m) - 1

			for i in range(lastm , -1 , -1) :
				maddress = smsbox.address(m[i])
				if	boxdic.has_key(maddress) :
					seq = boxdic.get(maddress)
					boxdic[maddress] = [m[i],seq[1]]
				else:
					boxdic[maddress] = [m[i],m[i]]

			boxdic[0] = m[0]
			writeboxfile(boxname , boxdic)

			list = boxdic.keys()
			list.remove(0)

			# 将当前信箱搜索到的联系人添加到索引
			global contactlist
			for x in list :
				if	x not in contactlist :
					contactlist.append(x)

	# 处理指定信箱，搜集所有相关短信地址
	def searchcontact(boxname):
		global smsbox
		m = smsbox.sms_messages()
		messagebox = [] # 存储当前信箱找到的所有指定联系人相关的短信地址
		global selectcontact
		boxdic = readboxfile(boxname)

		seq = []  # 存储当前信箱要处理的各联系人的首尾地址
		for x in selectcontact :
			if	boxdic.has_key(x) :
				seq.append(boxdic.get(x))  # 存储当前信箱要处理的各联系人的首尾地址序号

		if	0 < len(seq) :  # 如果当前信箱没有需要处理的联系人则跳过后续操作
			for i in range(0 , len(seq)) :
				if	0 == seq[i][0] :
					seq[i][0] = m[0]
				if	0 == seq[i][1] :
					seq[i][1] = m[len(m) - 1]

			seq.sort()

			head = m.index(seq[0][0])
			tail = m.index(seq[0][1])
			for i in range(head , tail + 1 ) :
				if	smsbox.address(m[i]) in selectcontact :
					messagebox.append(m[i])

			seq.remove(seq[0])

			for x in seq :
				thishead = m.index(x[0])
				thistail = m.index(x[1])
				if		thishead >= head and thistail <= tail :
						continue
				elif	thishead < head :
						for i in range(thishead , head) :
							if	smsbox.address(m[i]) in selectcontact :
								messagebox.append(m[i])
						head = thishead
				elif	thistail > tail :
						for i in range(tail + 1 , thistail + 1) :
							if	smsbox.address(m[i]) in selectcontact :
								messagebox.append(m[i])
						tail = thistail
				else :
						pass

		return messagebox

	# 建立联系人索引
	global contactlist
	contactlist = [] # 存储联系人列表
	appuifw.note('正在建立联系人索引，请稍候……'.decode("utf-8"),"info") # 提示信息：正在生成联系人列表

	if 	0 == box or 1 == box :   # 处理收件箱
		global smsbox
		smsbox = inbox.Inbox()
		searchbox("inbox")
	if 	0 == box or 2 == box :   # 处理已发箱
		global smsbox
		smsbox = inbox.Inbox(inbox.ESent)
		searchbox("sentbox")
	if 	0 == box or 3 == box :   # 处理发件箱
		global smsbox
		smsbox = inbox.Inbox(inbox.EOutbox)
		searchbox("outbox")
	if 	0 == box or 4 == box :   # 处理草稿箱
		global smsbox
		smsbox = inbox.Inbox(inbox.EDraft)
		searchbox("draftbox")

	# 显示所有联系人列表
	if	0 == len(contactlist) : # 列表为空
		appuifw.note('未发现联系人'.decode("utf-8"),"error")
		smsjd()
	else:
		appuifw.app.title='选择联系人'.decode("utf-8")
		appuifw.app.set_tabs([] , None)

		global soundset
		if	soundset : playsound("list") 

		selected = 0
		while 0 == selected:
			selectindex = appuifw.multi_selection_list(contactlist , style='checkbox', search_field=1) # 多选列表
			if	0 == len(selectindex) : # 用户未选择联系人
				if	appuifw.query('终止操作'.decode("utf-8"),'query') :
					break
			else:
				selected = 1
				break

		if	0 == selected :
			smsjd()
		else: 
			# 搜索所有指定联系人的相关短信
			appuifw.note('正在搜集短信\n请稍候……'.decode("utf-8"),"info") # 提示信息：正在搜索相关短信
			global selectcontact # 存储已选联系人列表
			selectcontact = []
			for x in selectindex :
				selectcontact.append(contactlist[x])

			global min , cin , msent , csent , mout , cout , mdraft , cdraft
			min = []    # 存储收件箱中待处理信息地址
			cin = []    # 存储收件箱中待处理信息内容
			msent = []  # 存储已发箱中待处理信息地址
			csent = []  # 存储已发箱中待处理信息内容
			mout = []   # 存储发件箱中待处理信息地址
			cout = []   # 存储发件箱中待处理信息内容
			mdraft = [] # 存储草稿箱中待处理信息地址
			cdraft = [] # 存储草稿箱中待处理信息地址

			if 	0 == box or 1 == box :   # 处理收件箱
				global smsbox
				smsbox = inbox.Inbox()
				min = searchcontact("inbox")
				if	0 < len(min) :
					cin = messagecontent(min)
			if 	0 == box or 2 == box :   # 处理已发箱
				global smsbox
				smsbox = inbox.Inbox(inbox.ESent)
				msent = searchcontact("sentbox")
				if	0 < len(msent) :
					csent = messagecontent(msent)
			if 	0 == box or 3 == box :   # 处理发件箱
				global smsbox
				smsbox = inbox.Inbox(inbox.EOutbox)
				mout = searchcontact("outbox")
				if	0 < len(mout) :
					cout = messagecontent(mout)
			if 	0 == box or 4 == box :   # 处理草稿箱
				global smsbox
				smsbox = inbox.Inbox(inbox.EDraft)
				mdraft = searchcontact("draftbox")
				if	0 < len(mdraft) :
					cdraft = messagecontent(mdraft)

			global soundset
			if	soundset : playsound("list") 

			handlemessage()  # 显示待处理短信函数入口


def op_keyword_check(box) :
	global firstrunset
	if	"done" <> firstrunset :
		kw = []
		newkeyword = appuifw.query('请输入关键字'.decode("utf-8") , "text")
		if	None <> newkeyword : 
			kw.append(newkeyword)
			filename = "e:\\system\\apps\\DJSMSJD\\DATA\\keywords"
			file = open(filename , 'w')
			file.write(repr(kw))
			file.close()

			configure = "e:\\system\\apps\\DJSMSJD\\DATA\\config"  # 读取配置文件
			configfile = e32dbm.open(configure , 'w')
			configfile["firstrun"] = "done"
			configfile.close()
			firstrunset = "done"

			op_keyword(box)
		else :
			smsjd()
	else :
		op_keyword(box)


# 关键字搜索
def op_keyword(box):
	global running
	running = 1
	import key_codes  # 数字按键键位编码
	appuifw.app.title = '关键字列表'.decode("utf-8")
	appuifw.app.set_tabs([] , None)

	filename = "e:\\system\\apps\\DJSMSJD\\DATA\\keywords"  
	file = open(filename , 'r')
	content = file.read()
	file.close()
	seq = eval(content)

	global keyword
	keyword = seq

	def rewritefile():
		global keyword
		filename = "e:\\system\\apps\\DJSMSJD\\DATA\\keywords"  
		file = open(filename , 'w')
		file.write(repr(keyword))
		file.close()

	def toview():
		global keyword
		index = appbody.current()
		appuifw.note(keyword[index])

	def todel():
		global keyword
		index = appbody.current()
		if	1 < len(keyword) :
			keyword.remove(keyword[index])
			rewritefile()
			appbody.set_list(keyword , index)
			appuifw.app.body = appbody
		else :
			appuifw.note('请保留至少一个关键字'.decode("utf-8") , "error")

	def addkeyword():
		global keyword
		index = appbody.current()
		newkeyword = appuifw.query('请输入关键字'.decode("utf-8") , "text")
		if	None <> newkeyword : 
			keyword.append(newkeyword)
			rewritefile()
			appbody.set_list(keyword , index)
			appuifw.app.body = appbody
		else :
			pass

	def tosearch(type) :
		global keyword

		appuifw.note('正在搜集短信\n请稍候……'.decode("utf-8"),"info")
		def searchtypeone():  # 匹配所有关键字方式
			global smsbox , keyword
			seq = []
			m = smsbox.sms_messages()
			for i in m :
				yes = 1
				rc = smsbox.content(i)
				for kw in keyword :
					if	-1 == rc.find(kw) :
						yes = 0
						break
				if	1 == yes : seq.append(i)
			return seq

		def searchtypetwo():  # 匹配任一关键字方式
			global smsbox , keyword
			seq = []
			m = smsbox.sms_messages()
			for i in m :
				yes = 0
				rc = smsbox.content(i)
				for kw in keyword :
					if	-1 <> rc.find(kw) :
						yes = 1
						break
				if	1 == yes : seq.append(i)
			return seq

		global min , cin , msent , csent , mout , cout , mdraft , cdraft
		min = []    # 存储收件箱中待处理信息地址
		cin = []    # 存储收件箱中待处理信息内容
		msent = []  # 存储已发箱中待处理信息地址
		csent = []  # 存储已发箱中待处理信息内容
		mout = []   # 存储发件箱中待处理信息地址
		cout = []   # 存储发件箱中待处理信息内容
		mdraft = [] # 存储草稿箱中待处理信息地址
		cdraft = [] # 存储草稿箱中待处理信息地址

		if 	0 == box or 1 == box :   # 处理收件箱
			global smsbox
			smsbox = inbox.Inbox()
			if	1 == type :
				min = searchtypeone()
			else :
				min = searchtypetwo()
			if	0 < len(min) :
				cin = messagecontent(min)

		if 	0 == box or 2 == box :   # 处理已发箱
			global smsbox
			smsbox = inbox.Inbox(inbox.ESent)
			if	1 == type :
				msent = searchtypeone()
			else :
				msent = searchtypetwo()
			if	0 < len(msent) :
				csent = messagecontent(msent)

		if 	0 == box or 3 == box :   # 处理发件箱
			global smsbox
			smsbox = inbox.Inbox(inbox.EOutbox)
			if	1 == type :
				mout = searchtypeone()
			else :
				mout = searchtypetwo()
			if	0 < len(mout) :
				cout = messagecontent(mout)

		if 	0 == box or 4 == box :   # 处理草稿箱
			global smsbox
			smsbox = inbox.Inbox(inbox.EDraft)
			if	1 == type :
				mdraft = searchtypeone()
			else :
				mdraft = searchtypetwo()
			if	0 < len(mdraft) :
				cdraft = messagecontent(mdraft)

		global soundset
		if	soundset : playsound("list") 

		handlemessage()  # 显示待处理短信函数入口

	def andsearch():
		tosearch(1)  # 匹配所有关键字方式

	def orsearch():
		tosearch(2)  # 匹配任一关键字方式

	appbody = appuifw.Listbox(keyword , toview)
	appbody.bind(key_codes.EKeyBackspace , todel)
	appuifw.app.body = appbody
	appuifw.app.menu = [('增加关键字'.decode("utf-8") , addkeyword),
						('匹配任一关键字'.decode("utf-8") , orsearch),
						('匹配所有关键字'.decode("utf-8") , andsearch)]


# 时间段筛选
def op_time(box):
	global running
	running = 1

	def timesearch(start , end) :
		appuifw.note('正在搜集短信\n请稍候……'.decode("utf-8"),"info")
		def searchfield():
			seq = []
			global smsbox
			m = smsbox.sms_messages()
			if	0 < len(m) :

				def dichotomy(thetime):  # 二分法查找
					head = 0 
					tail = len(m) - 1
					if	head <> tail :
						while 1 :
							nowpos = head + int((tail - head) / 2)
							if nowpos == head : break

							if		smsbox.time(m[nowpos]) == thetime :
									head = nowpos
									break
							elif	smsbox.time(m[nowpos]) > thetime :
									head = nowpos
							else :
									tail = nowpos
					else :
						pass
					return head

				if		-1 == start :  # 向前搜索
						pos = dichotomy(end)
						if	smsbox.time(m[pos]) <= end :
							seq.append(m[pos])
						try :
							pos += 1
							if	smsbox.time(m[pos]) <= end :
								seq.append(m[pos])
								for i in range(pos + 1 , len(m) + 1) :
									seq.append(m[i])
						except :
							pass

				elif	-1 == end :    # 向后搜索
						pos = dichotomy(start)
						if	smsbox.time(m[pos]) >= start :
							seq.append(m[pos])
							try :
								for i in range(0 , pos) :
									seq.append(m[i])
							except :
								pass

				else :                 # 区间搜索
						pos1 = dichotomy(start)
						pos2 = dichotomy(end)
						if	start <= smsbox.time(m[pos2]) <= end :
							seq.append(m[pos2])

						if	pos1 <> pos2 :
							for i in range(pos2 + 1 , pos1 + 1) :
								seq.append(m[i])
						else :
							pass

			else :
				pass
			return seq

		global min , cin , msent , csent , mout , cout , mdraft , cdraft
		min = []    # 存储收件箱中待处理信息地址
		cin = []    # 存储收件箱中待处理信息内容
		msent = []  # 存储已发箱中待处理信息地址
		csent = []  # 存储已发箱中待处理信息内容
		mout = []   # 存储发件箱中待处理信息地址
		cout = []   # 存储发件箱中待处理信息内容
		mdraft = [] # 存储草稿箱中待处理信息地址
		cdraft = [] # 存储草稿箱中待处理信息地址

		if 	0 == box or 1 == box :   # 处理收件箱
			global smsbox
			smsbox = inbox.Inbox()
			min = searchfield()
			if	0 < len(min) :
				cin = messagecontent(min)

		if 	0 == box or 2 == box :   # 处理已发箱
			global smsbox
			smsbox = inbox.Inbox(inbox.ESent)
			msent = searchfield()
			if	0 < len(msent) :
				csent = messagecontent(msent)

		if 	0 == box or 3 == box :   # 处理发件箱
			global smsbox
			smsbox = inbox.Inbox(inbox.EOutbox)
			mout = searchfield()
			if	0 < len(mout) :
				cout = messagecontent(mout)

		if 	0 == box or 4 == box :   # 处理草稿箱
			global smsbox
			smsbox = inbox.Inbox(inbox.EDraft)
			mdraft = searchfield()
			if	0 < len(mdraft) :
				cdraft = messagecontent(mdraft)

		global soundset
		if	soundset : playsound("list") 
		handlemessage()  # 显示待处理短信函数入口

	def searchtype(type) :

		if		1 == type :  # 向前搜索
				enddate = appuifw.query('输入最后日期'.decode("utf-8") , "date" , time.time() - 28800)
				if	None == enddate :
					smsjd()
				else :
					startdate = -1
					enddate += 115199  # 截至最后日期（中国东八区）当天的23:59:59
					timesearch(startdate , enddate)
		elif	2 == type :  # 向后搜索
				startdate = appuifw.query('输入起始日期'.decode("utf-8") , "date" , time.time() - 28800)
				if	None == startdate :
					smsjd()
				else :
					enddate = -1
					startdate += 28800
					timesearch(startdate , enddate)
		elif	3 == type :  # 区间搜索
				timeset = 0
				while 1 :
					startdate = appuifw.query('输入起始日期'.decode("utf-8") , "date" , time.time() - 28800)
					if None == startdate : break
					enddate = appuifw.query('输入最后日期'.decode("utf-8") , "date" , time.time() - 28800)
					if None == enddate : break
					if	startdate > enddate :
						appuifw.note('输入有误'.decode("utf-8"),"error")
					else :
						timeset = 1
						break
				if	0 == timeset : smsjd()
				else :
					enddate += 115199  # 截至最后日期（中国东八区）当天的23:59:59
					startdate += 28800  # 中国东八区
					timesearch(startdate , enddate)
		else :
				pass

	choices = ['向前搜索'.decode("utf-8") , '向后搜索'.decode("utf-8") , '区间搜索'.decode("utf-8")]
	index = appuifw.popup_menu(choices, '选择时间段'.decode("utf-8"))

	if		0 == index :  # 向前搜索
			searchtype(1)
	elif	1 == index :  # 向后搜索
			searchtype(2)
	elif	2 == index :  # 区间搜索
			searchtype(3)
	else :
			pass




# 字符数筛选
def op_byte(box):
	global running
	running = 1

	byteset = 0
	while 1 :  # 用户指定字符数
		byte = appuifw.query('请输入字符数上限'.decode("utf-8") , "number")
		if		None == byte :
				byteset = 0
				break
		elif	0 == byte :
				appuifw.note('字符数不能为零'.decode("utf-8") , "error")
		else :
				byteset = 1
				break

	if	0 == byteset :
		smsjd()
	else :
		appuifw.note('正在搜集短信\n请稍候……'.decode("utf-8") , "info")

		def bytesearch():
			global smsbox
			seq = []
			m = smsbox.sms_messages()
			for i in m :
				rc = smsbox.content(i)
				if len(rc) <= byte : seq.append(i)
			return seq

		global min , cin , msent , csent , mout , cout , mdraft , cdraft
		min = []    # 存储收件箱中待处理信息地址
		cin = []    # 存储收件箱中待处理信息内容
		msent = []  # 存储已发箱中待处理信息地址
		csent = []  # 存储已发箱中待处理信息内容
		mout = []   # 存储发件箱中待处理信息地址
		cout = []   # 存储发件箱中待处理信息内容
		mdraft = [] # 存储草稿箱中待处理信息地址
		cdraft = [] # 存储草稿箱中待处理信息地址

		if 	0 == box or 1 == box :   # 处理收件箱
			global smsbox
			smsbox = inbox.Inbox()
			min = bytesearch()
			if	0 < len(min) :
				cin = messagecontent(min)

		if 	0 == box or 2 == box :   # 处理已发箱
			global smsbox
			smsbox = inbox.Inbox(inbox.ESent)
			msent = bytesearch()
			if	0 < len(msent) :
				csent = messagecontent(msent)

		if 	0 == box or 3 == box :   # 处理发件箱
			global smsbox
			smsbox = inbox.Inbox(inbox.EOutbox)
			mout = bytesearch()
			if	0 < len(mout) :
				cout = messagecontent(mout)

		if 	0 == box or 4 == box :   # 处理草稿箱
			global smsbox
			smsbox = inbox.Inbox(inbox.EDraft)
			mdraft = bytesearch()
			if	0 < len(mdraft) :
				cdraft = messagecontent(mdraft)

		global soundset
		if	soundset : playsound("list") 
		handlemessage()  # 显示待处理短信函数入口


# 建立待处理短信列表
def messagecontent(seq):
	global smsbox
	mcontent = []
	for i in seq :
		mcontent.append(smsbox.content(i))
	return mcontent


# 显示待处理短信
def handlemessage():
	appuifw.app.title = '查找到的短信'.decode("utf-8")
	appuifw.app.exit_key_handler = background
	global min , cin , msent , csent , mout , cout , mdraft , cdraft
	if	0 == len(min) + len(msent) + len(mout) + len(mdraft) :
		if	appuifw.query('没有找到短信\n是否重新操作'.decode("utf-8"),'query') :
			smsjd()
		else :
			background()
	else :
		import key_codes # 数字按键键位编码

		nin = -1
		nsent = -1
		nout = -1
		ndraft = -1
		now = 0

		# 查看选中的短信
		def viewmessage(mindex , cindex):
			appuifw.app.set_tabs([] , None)
			old_body = appuifw.app.body
			def exit_view():
				appuifw.app.body = old_body
				global activate_index
				appuifw.app.set_tabs(options , handle_tab)
				appuifw.app.activate_tab(activate_index)
				appuifw.app.exit_key_handler = background

			global smsbox
			mad = smsbox.address(mindex)
			mtime = time.localtime(smsbox.time(mindex))
			mdate = time.strftime("%Y年%m月%d日" , mtime).decode("utf-8")
			mtime = time.strftime("%H时%M分%S秒" , mtime).decode("utf-8")

			if	mindex in min :  # 如果当前是收件箱则显示“发件人”，否则显示“收件人”
				view = '——————————————\n发件人：'.decode("utf-8")
			else :
				view = '——————————————\n收件人：'.decode("utf-8")

			view += mad + '\n——————————————\n日   期：'.decode("utf-8") + mdate + '\n时   间：'.decode("utf-8") + mtime + '\n——————————————\n内   容：'.decode("utf-8") + cindex + '\n——————————————'.decode("utf-8")

			appuifw.app.body = appuifw.Text(view)
			appuifw.app.body.set_pos(0)
			appuifw.app.exit_key_handler = exit_view

		def view_inbox():
			index = appinbox.current()
			global smsbox
			smsbox = inbox.Inbox()
			viewmessage(min[index] , cin[index])

		def view_sentbox():
			index = appsentbox.current()
			global smsbox
			smsbox = inbox.Inbox(inbox.ESent)
			viewmessage(msent[index] , csent[index])

		def view_outbox():
			index = appoutbox.current()
			global smsbox
			smsbox = inbox.Inbox(inbox.EOutbox)
			viewmessage(mout[index] , cout[index])

		def view_draftbox():
			index = appdraftbox.current()
			global smsbox
			smsbox = inbox.Inbox(inbox.EDraft)
			viewmessage(mdraft[index] , cdraft[index])

		def del_inbox():
			index = appinbox.current()
			min.remove(min[index])
			cin.remove(cin[index])
			appinbox.set_list(cin , index)
			appuifw.app.body = appinbox

		def del_sentbox():
			index = appsentbox.current()
			msent.remove(msent[index])
			csent.remove(csent[index])
			appsentbox.set_list(csent , index)
			appuifw.app.body = appsentbox

		def del_outbox():
			index = appoutbox.current()
			mout.remove(mout[index])
			cout.remove(cout[index])
			appoutbox.set_list(cout , index)
			appuifw.app.body = appoutbox

		def del_draftbox():
			index = appdraftbox.current()
			mdraft.remove(mdraft[index])
			cdraft.remove(cdraft[index])
			appdraftbox.set_list(cdraft , index)
			appuifw.app.body = appdraftbox

		options = [] # 存储要显示的信箱名称

		if	0 < len(min) :
			options.append('收件箱'.decode("utf-8"))
			appinbox = appuifw.Listbox(cin , view_inbox)
			appinbox.bind(key_codes.EKeyBackspace , del_inbox)
			nin = now
			now += 1
		if	0 < len(msent) :
			options.append('已发箱'.decode("utf-8"))
			appsentbox	= appuifw.Listbox(csent , view_sentbox) 
			appsentbox.bind(key_codes.EKeyBackspace , del_sentbox)
			nsent = now
			now += 1
		if	0 < len(mout) :
			options.append('发件箱'.decode("utf-8"))
			appoutbox	= appuifw.Listbox(cout , view_outbox) 
			appoutbox.bind(key_codes.EKeyBackspace , del_outbox)
			nout = now
			now += 1
		if	0 < len(mdraft) :
			options.append('草稿箱'.decode("utf-8"))
			appdraftbox	= appuifw.Listbox(cdraft , view_draftbox) 
			appdraftbox.bind(key_codes.EKeyBackspace , del_draftbox)
			ndraft = now

		def handle_tab(index):
			global activate_index
			activate_index = index
			if		index == nin : 
					appuifw.app.body = appinbox
			elif	index == nsent :
					appuifw.app.body = appsentbox
			elif	index == nout :
					appuifw.app.body = appoutbox
			elif	index == ndraft :
					appuifw.app.body = appdraftbox
			else :
					pass

		if	1 >= len(options) :
			appuifw.app.set_tabs([] , None)
		else :
			appuifw.app.set_tabs(options , handle_tab)

		if		0 == nin : 
				appbody = appinbox
		elif	0 == nsent :
				appbody = appsentbox
		elif	0 == nout :
				appbody = appoutbox
		elif	0 == ndraft :
				appbody = appdraftbox
		else :
				pass

		global activate_index
		activate_index = 0
		appuifw.app.body = appbody
		appuifw.app.menu = [('清理短信'.decode("utf-8") , deletemessage)]


# 清理短信
def deletemessage(): 
	global min , msent , mout , mdraft
	number = len(min) + len(msent) + len(mout) + len(mdraft)
	if	appuifw.query('共计%d条短信\n确认删除'.decode("utf-8") % number , "query"):

		recordstatus("failed")  # 容灾处理
		choices = []
		appuifw.note('正在清理短信\n请稍候……'.decode("utf-8") , "info")

		if	0 < len(min) :
			choices.append('收件箱%d条'.decode("utf-8") % len(min))
			global smsbox
			smsbox = inbox.Inbox()
			for i in min :
				smsbox.delete(i)
		if	0 < len(msent) :
			choices.append('已发箱%d条'.decode("utf-8") % len(msent))
			global smsbox
			smsbox = inbox.Inbox(inbox.ESent)
			for i in msent :
				smsbox.delete(i)
		if	0 < len(mout) :
			choices.append('发件箱%d条'.decode("utf-8") % len(mout))
			global smsbox
			smsbox = inbox.Inbox(inbox.EOutbox)
			for i in mout :
				smsbox.delete(i)
		if	0 < len(mdraft) :
			choices.append('草稿箱%d条'.decode("utf-8") % len(mdraft))
			global smsbox
			smsbox = inbox.Inbox(inbox.EDraft)
			for i in mdraft :
				smsbox.delete(i)

		recordstatus("succeed")

		global soundset
		if	soundset : playsound("del") 
		appuifw.popup_menu(choices , '短信清理完毕'.decode("utf-8"))

		background()
	else :
		handlemessage()


# 重建联系人数据文件
def rebuildcontact():
	root = "e:\\system\\apps\\DJSMSJD\\DATA\\"
	def writefile(box):
		file = open(box,"w")
		file.write("{0: 0}")
		file.close()
	writefile(root + "inbox")
	writefile(root + "outbox")
	writefile(root + "sentbox")
	writefile(root + "draftbox") 


# 记录状态，是否需要从前次崩溃中恢复的依据
def recordstatus(status):
	configure = "e:\\system\\apps\\DJSMSJD\\DATA\\config"  # 读取配置文件
	configfile = e32dbm.open(configure,'w')
	configfile["status"] = status
	configfile.close()


# 播放声音
def playsound(filename):
	import audio
	delay=e32.Ao_timer()

	soundfile = "e:\\system\\apps\\DJSMSJD\\SOUND\\" + filename + ".mp3"  # 声音文件路径

	voice=audio.Sound.open(soundfile)
	voice.play()
	while voice.state() == audio.EPlaying:
		delay.after(0.01)
	voice.stop()
	voice.close()


# 程序初始化
def DJSMSJD():
	configure = "e:\\system\\apps\\DJSMSJD\\DATA\\config"  # 读取配置文件
	configfile = e32dbm.open(configure,'w')

	# 容灾处理
	if 	"failed" == configfile.get("status") :
		rebuildcontact() # 重建联系人数据
		configfile["status"] = "succeed"

	global soundset # 音效开关
	if	"on" == configfile.get("sound") : 
		soundset = 1
	else :
		soundset = 0

	global passwordset
	passwordset = configfile.get("password")

	global firstrunset
	firstrunset = configfile.get("firstrun")

	configfile.close()

	# 用户口令
	if	"0" == passwordset :
		pass
	else :
		psw = appuifw.query('请输入用户口令'.decode("utf-8") , 'code')
		if	psw == passwordset :
			pass
		else :
			appuifw.note('口令错误\n请再输一次'.decode("utf-8") , 'error')
			psw = appuifw.query('请输入用户口令'.decode("utf-8") , 'code')
			if	psw == passwordset :
				pass
			else :
				appuifw.note('口令错误\n无权使用'.decode("utf-8") , 'error')
				global running
				running = 0
				exit()

	background()
	if	soundset : playsound("start")  # 如果音效设置为开则播放

	if	"never" == firstrunset :
		configfile = e32dbm.open(configure,'w')
		configfile["firstrun"] = "read"
		configfile.close()
		if	appuifw.query('这是您首次运行\n请查看使用说明'.decode("utf-8") , 'query') : help()


app_lock = e32.Ao_lock()
DJSMSJD()  # 程序入口
app_lock.wait()